﻿var feedURL = "http://www.thefreedictionary.com/_/WoD/rss.aspx?type=article";
var http = null;
var currentIndex;
var timer = null;
var anim = null;
var dailyTimer = null;

function view_onOpen() {
  get_History();
  if(dailyTimer) {
    clearInterval(dailyTimer); 
    dailyTimer = null;
  }
  dailyTimer = setInterval( "get_History()", 60 * 60 * 1000 ); //Check every hour
}

function get_History() {
  title_l.visible = false;
  currentIndex = 0;
  next.visible = false;
  prev.visible = false;
  pubD.visible = false;
  titleArray = new Array();
  linkArray = new Array();
  descArray = new Array();
  pubArray = new Array();
  http = new XMLHttpRequest();
  try { 
    http.open("GET", feedURL, true); 
  } 
  catch (e) { 
    http = null; 
    return;
  }
  http.onreadystatechange = OnReceivedData;
  try { 
    http.send(); 
  }
  catch(e) {  
  }
}

function OnReceivedData() {
  var pubDate, title, link, desc;
  if (http.readyState == 1)
    animateLoading();
  if (http.readyState != 4) {
    return;
  }
  if (http.status != 200) {
    stopAnimation();
    title_l.visible = true;
    if(dailyTimer) {
      clearInterval(dailyTimer); 
      dailyTimer = null;
    }
    dailyTimer = setInterval( "view_onOpen()", 60 * 1000 ); //Check every minute
    title_l.innerText = strFail;
    descArray[currentIndex] = strMsg;
    titleArray[currentIndex] = GADGET_NAME;
    linkArray[currentIndex] = "http://gadgets.jsplash.com";
    return;
  } 

  var doc = new DOMDocument();
  doc.loadXML(http.responseText);

  var elem = doc.getElementsByTagName("item");
  for(var i = 0;i < elem.length ;i++) {
    if (elem != null && elem.length > 0) {
      for (var node = elem[i].firstChild; node != null; node = node.nextSibling) {
        if (node.nodeName == "pubDate") {
          pubDate = node.firstChild.nodeValue;  
          pubArray.push(pubDate);
         }
        if (node.nodeName == "title") {
          title = node.firstChild.nodeValue;  
          titleArray.push(title);
         }
        if (node.nodeName == "link") {
          link = node.firstChild.nodeValue; 
          linkArray.push(link);
        }
        if (node.nodeName == "description") {
          desc = node.firstChild.nodeValue;
          descArray.push(desc);
        }
      }
    }
  }
  fillDetails();
}

function fillDetails() {
  stopAnimation();
  title_l.visible = true;
  next.visible = true;
  prev.visible = true;
  pubD.visible = true;
  title_l.innerText = titleArray[currentIndex];
  var currentY = new Date();
  pubD.innerText = pubArray[currentIndex].substring(0, pubArray[currentIndex].indexOf(" "+currentY.getYear()));
}

function item_Click() {
  var details = new DetailsView();
  snippet = descArray[currentIndex];
  details.html_content = true;
  details.SetContent(undefined, undefined, snippet, false, 0);
  plugin.showDetailsView(details, titleArray[currentIndex], gddDetailsViewFlagToolbarOpen, onDetailsViewFeedback);
}

function onDetailsViewFeedback(detailsViewFlags) {
  //Optionally respond to details view's closure.

  if (detailsViewFlags == gddDetailsViewFlagNone) {
    // User closed the details view
  } else if (detailsViewFlags == gddDetailsViewFlagToolbarOpen) {
    // User clicked on the title of the details view
    var winShell = new ActiveXObject("Shell.Application"); 
    winShell.ShellExecute(linkArray[currentIndex]); 
    winShell = null;
  }
}

function next_Click() {
  currentIndex = (++currentIndex==titleArray.length)?0:currentIndex;
  fillDetails();
}

function prev_Click() {
  currentIndex = (--currentIndex<0)?titleArray.length-1:currentIndex;
  fillDetails();

}

function animateLoading() {
  loading.visible = true;
  timer = setInterval( "animate_rewind()", 501 );
}

function animate_rewind() {
  anim = beginAnimation("animate()",0,360,500);
}

function animate() {
  loading.rotation = event.value;
}

function stopAnimation() {
  if(timer) {
    clearInterval(timer); 
    timer = null;
  }
  if (anim) {
    cancelAnimation(anim);
    anim = null;
  }
  loading.visible = false;
}

function launch_url()
{
  var winShell = new ActiveXObject("Shell.Application"); 
  winShell.ShellExecute("http://gadgets.jsplash.com"); 
  winShell = null;
}